' FFSubmenu=Bildtransfer
' FFName=Dropbox Upload
' Bilder in den lokalen Dropbox-Ordner kopieren. Es wird Ordner unter \fotos\ erstellt bzw. verwendet
' KGsoft (praetor) 
' Version 1.0 vom 09.10.2016	erste ffentliche Version
' Version 1.1 vom 10.10.2016	fehlende Dropbox-Installation wird behandelt

Option Explicit
Const Version = "V 1.1"
Const Fotoordner = "\foto\"				' Unterordner in der Dropbox, wo die Alben angelegt werden
Dim Suchmuster 
Suchmuster = ":|""|<|>|\*|/|\?|\\|\|"	' Zeichen in Ordnern nicht zulssig ->  :"<>*/?\|
Dim WshShell
Dim fso
Dim Aufruf
Dim Albumfeld
Dim i
Dim TypQuelle, ListeBilder, AnzahlBilder
Dim AktAlbum
Dim Ordner, Loeschalbum, Erstellalbum
Dim ofolders
Dim osubfolder
Dim VerzX
Dim DBPfad
Dim albumnameOK
Dim albumzaehler
Dim HelpDialogName
Dim Taste
Dim AnzDateien

Set WshShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

if DropboxPfad = "" Then		' keine lokale Dropbox -> Skriptende
	Msgbox "Eine lokale Dropbox-Installation konnte nicht gefunden werden." & vbNewLine & "Das Skript wird beendet.", 48,"Dropbox Upload"
Else
	DBPfad = DropboxPfad & Fotoordner
	Call Main
End If

Sub Main
	If not fso.FolderExists(DBPfad) Then					' Fotoordner fehlt noch
		fso.CreateFolder(DBPfad)
		Msgbox "Im lokalen Dropbox-Ordner wurde der Unterordner " & Fotoordner & " erstellt." & vbNewLine & "In diesem werden die Alben angelegt.", 64, "Dropbox Upload"
	End If
	Call Dialogaufbau
	Call Bilder_einlesen
	Call Alben_einlesen
	TypQuelle = 0
	
	FF_SetDialogTimer "Dropbox Upload", 100
	Do										' Auswertung Button im Dialog		
		Select Case FF_ShowDialog("Dropbox Upload")
			Case "TIMER"
				FF_SetControl "Dropbox Upload","Version", Version
				FF_SetControl "Dropbox Upload", "bol_zusatz", "1"
				FF_SetControl "Dropbox Upload","Anzahl", AnzahlBilder + 1
				FF_SetDialogTimer "Dropbox Upload", 0
			Case "quelle_comb"
				Select Case FF_GetControl ("Dropbox Upload", "quelle_comb")
					Case "Computer-Ansicht, alle Bilder"
						TypQuelle = 0
						Call Bilder_einlesen
					Case "Computer-Ansicht, markierte Bilder"
						TypQuelle = 1
						Call Bilder_einlesen
					Case "Bilderliste, alle Bilder"
						TypQuelle = 2
						Call Bilder_einlesen
					Case "Bilderliste, markierte Bilder"
						TypQuelle = 3
						Call Bilder_einlesen
					Case "Bilde auf Arbeitsflche"
						TypQuelle = 4
						Call Bilder_einlesen
				End Select
				FF_SetControl "Dropbox Upload","Anzahl", AnzahlBilder + 1
			Case "akt_button"
				Call Bilder_einlesen
				FF_SetControl "Dropbox Upload","Anzahl", AnzahlBilder + 1
			Case "Kopieren"
				' Bildquelle nochmals aktualisiern
				Call Bilder_einlesen
				FF_SetControl "Dropbox Upload","Anzahl", AnzahlBilder + 1
				
				albumnameOK = true
				If FF_GetControl("Dropbox Upload","album_edit") <> "" Then	' Neues Album
					Call Album_erstellen
				End If
				If albumnameOK = true Then
					FF_SetControl "Dropbox Upload","album_edit", ""
					FF_SetControl "Dropbox Upload","info_edit", "Kopiervorgang luft ..."
					FF_RefreshDialog "Dropbox Upload"							' damit nderung in info_edit sichtbar wird
					AktAlbum = DBPfad & FF_GetControl("Dropbox Upload","album_comb") & "/"
					if FF_GetControl("Dropbox Upload", "bol_ersatz") = "1" Then
						fso.DeleteFile(AktAlbum & "*.*")						' Album-Ornder zunchst leeren	
					End If
					For i = 0 to AnzahlBilder 
						fso.CopyFile ListeBilder(i), AktAlbum
						FF_SetControl "Dropbox Upload","Fortschritt",(i+1)/(AnzahlBilder+1)*100					
					Next
					FF_SetControl "Dropbox Upload","info_edit", "Es wurden " & AnzahlBilder + 1 & " Bilder in das Album " & AktAlbum & " kopiert."
				End If
			Case "... aus dem Bilderverzeichnis"
				FF_SetControl "Dropbox Upload","album_edit", fso.GetFileName(FF_GetImagePath()) 
			Case "Album erstellen"
				If FF_GetControl("Dropbox Upload","album_edit") <> "" Then
					Call Album_erstellen					
				End If
			Case "but_del"
				FF_SetControl "Dropbox Upload","info_edit", ""
				Loeschalbum = DBPfad & FF_GetControl("Dropbox Upload","album_comb")
				Set ofolders = fso.GetFolder(Loeschalbum)
				AnzDateien = ofolders.Files.Count					'Anzahl Dateien im Ordner ermitteln
				Set ofolders = Nothing 
				if MsgBox ("Der Ordner <" & Loeschalbum & "> mit " & AnzDateien & " enthaltenen Bildern wird gelscht." & vbNewLine & vbNewLine &"Tatschlich fortfahren?", 36, "Dropbox-Album lschen") = 6 Then
					fso.deletefolder Loeschalbum
					FF_SetControl "Dropbox Upload","album_comb", ""
					Call Alben_einlesen
					FF_SetControl "Dropbox Upload","info_edit", "Das Album <" & Loeschalbum & "> wurde gelscht."
				End If
			Case "bol_zusatz"
				if FF_GetControl("Dropbox Upload", "bol_zusatz") = "1" Then
					FF_SetControl "Dropbox Upload", "bol_ersatz", "0"
				End If
			Case "bol_ersatz"
				if FF_GetControl("Dropbox Upload", "bol_ersatz") = "1" Then
					FF_SetControl "Dropbox Upload", "bol_zusatz", "0"
				End If
			Case "Alben im Explorer"
				Aufruf = "explorer.exe " & DBPfad
				Set WSHShell = CreateObject("WScript.Shell")
				WSHShell.Run Aufruf
			Case "?"
				HelpDialogName = "Kurze Erluterung"
				Call BildView100 (FF_GetScriptPath & "\dropboxuploadhilfe.png", HelpDialogName)
				Do		
					Select Case FF_ShowDialog(HelpDialogName)
						Case "OK", "CANCEL"
							FF_CloseDialog HelpDialogName
						Exit Do
					End Select
				Loop
			Case "Schlieen", "CANCEL"
				set fso = nothing
				set WshShell = nothing
				Exit Sub
		End Select
	Loop
End Sub

Sub Alben_einlesen
	Set ofolders = fso.getfolder(DBPfad)
	Set osubfolder = ofolders.Subfolders
	For Each VerzX in osubfolder
		FF_SetControl "Dropbox Upload","album_comb", VerzX.Name		
	Next
	set osubfolder = nothing
	set ofolders = nothing
End Sub

Sub Album_erstellen
	Erstellalbum = FF_GetControl("Dropbox Upload","album_edit")
		if SearchRegAusdr(Erstellalbum, Suchmuster, false) = false Then		' Suchmuster nicht gefunden
		If fso.FolderExists(DBPfad & Erstellalbum) Then						' Album schon vorhanden?
			FF_SetControl "Dropbox Upload","album_comb", Erstellalbum		' setzt Eintrag als Vorgabe
		Else		
			fso.CreateFolder(DBPfad & Erstellalbum)
			FF_SetControl "Dropbox Upload","album_comb", Erstellalbum
			FF_SetControl "Dropbox Upload","album_comb", Erstellalbum		' setzt Eintrag als Vorgabe
		End If
	Else
		albumnameOK = false
		Msgbox "Der Name fr das Album enthlt unzulssige Zeichen.", 48, "Dropbox Upload"
	End If
End Sub

Sub Bilder_einlesen
	if TypQuelle < 4 Then
		ListeBilder = split(FF_GetSelection(TypQuelle), vbNewLine)	
		AnzahlBilder = ubound(ListeBilder)
	Else
		if FF_GetDirty() = False Then			' Bild auf Arbeitsbereich ist gespeichert
			ListeBilder = split(FF_GetImageName(-1), vbNewLine)
			AnzahlBilder = ubound(ListeBilder)
		Else
			MsgBox "Das Bild im Arbeitsbereich muss zunchst gespeichert werden, bevor es hochgeladen werden kann."
			AnzahlBilder = -1
		End If
	End If
End Sub

Sub Dialogaufbau
	'** Start Dialog Dropbox Upload **
	FF_AddDialog "Dropbox Upload",185,170
	FF_AddControl "Dropbox Upload","Bilder in Dropbox-Albumordner kopieren","GROUP",4,90,175,36
	FF_AddControl "Dropbox Upload","Dropbox-Alben","GROUP",4,33,175,53
	FF_AddControl "Dropbox Upload","Bilderquelle","GROUP",4,4,175,25
	FF_AddControl "Dropbox Upload","album_comb","COMBO",7,43,152,10
	FF_AddControl "Dropbox Upload","Schlieen","BUTTON",134,131,41,13
	FF_AddControl "Dropbox Upload","Kopieren","BUTTON",134,100,41,22
	FF_AddControl "Dropbox Upload","album_edit","EDIT",51,58,124,10
	FF_AddControl "Dropbox Upload","quelle_comb","COMBO",7,13,111,10
	FF_AddControl "Dropbox Upload","Alben im Explorer","BUTTON",73,131,54,13
	FF_AddControl "Dropbox Upload","Anzahl:","STATIC",139,12,21,11
	FF_AddControl "Dropbox Upload","Anzahl","STATIC",162,12,14,11
	FF_AddControl "Dropbox Upload","neu erstellen:","STATIC",9,58,41,11
	FF_AddControl "Dropbox Upload","Version","STATIC",28,131,24,11
	FF_AddControl "Dropbox Upload","?","BUTTON",7,131,15,13
	FF_AddControl "Dropbox Upload","akt_button","BUTTON",122,12,11,11
	FF_AddControl "Dropbox Upload","... aus dem Bilderverzeichnis","BUTTON",7,71,84,11
	FF_AddControl "Dropbox Upload","bol_zusatz","BOOL",7,103,8,8
	FF_SetControlStyle "Dropbox Upload","bol_zusatz",16384
	FF_AddControl "Dropbox Upload","bol_ersatz","BOOL",7,114,8,8
	FF_SetControlStyle "Dropbox Upload","bol_ersatz",16384
	FF_AddControl "Dropbox Upload","Bilder hinzufgen bzw. aktualisieren","STATIC",19,101,107,11
	FF_AddControl "Dropbox Upload","Bilder ersetzen","STATIC",19,113,49,11
	FF_AddControl "Dropbox Upload","but_del","BUTTON",164,42,11,11
	FF_AddControl "Dropbox Upload","info_edit","EDIT",0,153,185,18
	FF_SetControlStyle "Dropbox Upload","info_edit",2048
	FF_AddControl "Dropbox Upload","Fortschritt","PROGRESS",0,148,185,6
	'** End Dialog Dropbox Upload **
	
	FF_SetControlImage "Dropbox Upload", "akt_button", FF_GetScriptPath & "\aktualisieren.png"
	FF_SetControlImage "Dropbox Upload", "but_del", FF_GetScriptPath & "\muelleimer1.png"
	
	FF_SetControl "Dropbox Upload","quelle_comb", "Computer-Ansicht, alle Bilder"
	FF_SetControl "Dropbox Upload","quelle_comb", "Computer-Ansicht, markierte Bilder"
	FF_SetControl "Dropbox Upload","quelle_comb", "Bilderliste, alle Bilder"
	FF_SetControl "Dropbox Upload","quelle_comb", "Bilderliste, markierte Bilder"
	FF_SetControl "Dropbox Upload","quelle_comb", "Bilde auf Arbeitsflche"
	
	' Tooltips
	FF_SetControlTooltip "Dropbox Upload", "but_del", "Lscht ein Album, d.h. den entsprechenden Ordner in der Dropbox."  
	FF_SetControlTooltip "Dropbox Upload", "akt_button", "Aktualisiert die Bilderquellen. Dies erfolgt stets auch noch mal vor dem Kopiervorgang."
	FF_SetControlTooltip "Dropbox Upload", "... aus dem Bilderverzeichnis", "Das aktuelle Computerverzeichnis wird als Namensvorschlag fr das neue Album bernommen."
	FF_SetControlTooltip "Dropbox Upload", "album_edit", "Name des neu zu erstellendes Albums im Dropbox-Ordner."
	FF_SetControlTooltip "Dropbox Upload", "Alben im Explorer", "ffnet der Dropbox-Fotoordner (" & DBPfad & ") im Explorer." & vbNewLine &	"Dort knnen die Alben fr Dritte freigegeben werden."
	FF_SetControlTooltip "Dropbox Upload", "bol_zusatz", "Neue Bilder werden dem Album zugefgt, dort vorhandenen Bilder bleiben bestehen, gleichnamige werden berschrieben."
	FF_SetControlTooltip "Dropbox Upload", "bol_ersatz", "Alle vorhandenen Bilder werden gelscht, bevor die neuen Bilder in das Album kopiert werden."
	FF_SetControlTooltip "Dropbox Upload", "Kopieren", "Kopiert die Bilder aus der Bildquelle in das gewhlte Album im Dropbox-Ordner."
	FF_SetControlTooltip "Dropbox Upload", "album_comb", "Alle Ordner in " & DBPfad
End Sub

Function DropBoxPfad
	' ermittelt den lokalen Pfad des DropBox-Ordners
	' wird keine Dropbox-Installation gefunden, wird ein leerer String zurck gegeben
	' Andreas Kleingnther, 160802
	Dim WshShell
	Dim fso
	Const ForReading = 1, ForWriting = 2
	Dim AppDataPfad
	Dim aktOrdner
	Dim DropInfo
	Dim f
	Dim DropInfoText
	' Systemordner Appdata ermitteln
	Set WshShell = CreateObject ("WScript.Shell")
	Set fso = CreateObject("Scripting.FileSystemObject")
	AppDataPfad = WshShell.Environment("Process")("APPDATA")
	aktOrdner = Right(AppDataPfad, Len (AppDataPfad) - InStrRev(AppDataPfad, "\",-1, 1))
	if aktOrdner <> "AppData" Then
		' aktueller Ordner ist Roaming oder Local oder LocalLow
		AppDataPfad = Left(AppDataPfad, InStrRev(AppDataPfad, "\",-1, 1))     ' AppDataPfad auf \appdata\ setzen
	End If
	' Standort info.json ermitteln
	DropInfo = ""
	If fso.FileExists(AppDataPfad & "Roaming\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "Roaming\Dropbox\info.json"
	end If
	If fso.FileExists(AppDataPfad & "Local\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "Local\Dropbox\info.json"
	end If
	If fso.FileExists(AppDataPfad & "LocalLow\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "LocalLow\Dropbox\info.json"
	end If
	if DropInfo <> "" Then
		' Ermittlung Dropbox-Pfad aus der info.json
		' Annahme: Pfad steht nach dem String "path" zwischen dem folgenden beiden Anfhrungszeichen
		Set f = fso.OpenTextFile(DropInfo, ForReading)
			DropInfoText =   f.ReadAll
		' schrittweises Vorgehen, um evtl. individuelle Abweichungen abzufangen
		DropInfoText = Right(DropInfoText, Len (DropInfoText) - InStr(1, DropInfoText, "path", 1)-4)    'linken Teil bis path" abschneiden
		DropInfoText = Right(DropInfoText, Len (DropInfoText) - InStr(1,DropInfoText, Chr(34), 1))    'linken Teil bis nchstes " abschneiden
		DropBoxPfad = Left(DropInfoText, InStr(1,DropInfoText, Chr(34), 1)-1)   	'linken Teil bis nchstes " retten
		DropBoxPfad = Replace (DropBoxPfad, "\\", "\")								' doppelte \\ durch einfache \ ersetzen
		set fso = nothing
		set WshShell = nothing
	Else														' keine Dropbox gefunden
		set fso = nothing
		set WshShell = nothing
		DropBoxPfad = ""
	End If
End Function

Function SearchRegAusdr(Zeichenfolge, Muster, GrossKleinBeachten)
' Vergleich einer Zeigenfolge mit einem Suchmuster, bei bereinstimmung
' wird True zurckgegeben, sonst False
    Dim regAusdr
    Set regAusdr = New RegExp
    regAusdr.Pattern = Muster
    regAusdr.IgnoreCase = GrossKleinBeachten    ' Bercksichtigung der Gro-/Kleinschreibung
    regAusdr.Global = True                      ' legt globales Anwenden fest
    If regAusdr.Test(Zeichenfolge) then
        SearchRegAusdr = True
    Else
        SearchRegAusdr = False
    End If
	REM SearchRegAusdr = False	' Test
End Function

Sub BildView100 (Bild, Dialogname)
	' erstellt einen Dialog, in dem das bergebene Bild mit 100%-Skalierung angezeigt wird
	' Bilddatei -> vollstndiger Pfad der Bilddatei
	' Dialogname -> Bezeichung, die im Kopf des Dialogfensters angezeigt wird
	' Andreas Kleingnther, 161008
	
	Dim g_XUnits,g_YUnits
	Dim UnitX, UnitY
	Dim Bild_X, Bild_Y
	Const SM_CXSCREEN=0
    Const SM_CYSCREEN=1
	
    g_XUnits=FF_GetSystemMetrics(SM_CXSCREEN)*4\(CDbl(FF_GetDialogBaseUnits) Mod &h10000&)
    g_YUnits=FF_GetSystemMetrics(SM_CYSCREEN)*8\(CDbl(FF_GetDialogBaseUnits)  \  &h10000&)
	Bild_X = FF_GetImageFileWidth(Bild)
	Bild_Y = FF_GetImageFileHeight(Bild) 
	UnitX = Bild_X * g_XUnits / FF_GetSystemMetrics(0)
	UnitY = Bild_Y * g_YUnits / FF_GetSystemMetrics(1)
	
	 '** Start Dialog Dialogname **
	FF_AddDialog Dialogname, UnitX+1, UnitY+15		' +1 fr dezenten Rahmen, + 15 ft PLatz fr OK-Button
	FF_AddControl Dialogname,"img1","IMAGE",0 ,0 ,UnitX, UnitY		
	FF_AddControl Dialogname,"OK","BUTTON", UnitX-40, UnitY, 40, 12
	'** End Dialog Dialogname **
	FF_SetControl Dialogname, "img1", Bild
	REM FF_ShowDialog Dialogname					' Aufruf erfolgt oben
End Sub
